Loading...
Searching...
No Matches
CoinAbcCommon.hpp File Reference
`#include "CoinPragma.hpp"`
`#include "CoinUtilsConfig.h"`
`#include <iostream>`
`#include <string>`
`#include <cassert>`
`#include <cstdio>`
`#include <cmath>`
`#include "AbcCommon.hpp"`
`#include "CoinHelperFunctions.hpp"`
`#include <endian.h>`
Include dependency graph for CoinAbcCommon.hpp:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Classes

class | AbcTolerancesEtc

## Macros

#define | COIN_FAC_NEW
#define | ABC_INLINE
#define | ABC_PARALLEL 0
#define | cilk_for for
#define | cilk_spawn
#define | cilk_sync
#define | SLACK_VALUE 1
#define | ABC_INSTRUMENT 1
#define | instrument_start(name, x)
#define | instrument_add(x)
#define | instrument_end()
#define | instrument_do(name, x)
#define | instrument_end_and_adjust(x)
#define | ABC_INTEL
#define | CoinFabs(x)
#define | TEST_DOUBLE_NONZERO(x)
#define | USE_TEST_INT_ZERO
#define | TEST_INT_NONZERO(x)
#define | TEST_DOUBLE_REALLY_NONZERO(x)
#define | TEST_DOUBLE_NONZERO_REGISTER(x)
#define | USE_FIXED_ZERO_TOLERANCE
#define | TEST_LESS_THAN_TOLERANCE(x)
#define | TEST_LESS_THAN_UPDATE_TOLERANCE(x)
#define | TEST_LESS_THAN_TOLERANCE_REGISTER(x)
#define | ABC_EXPONENT(x)
#define | TEST_EXPONENT_LESS_THAN_TOLERANCE(x)
#define | TEST_EXPONENT_LESS_THAN_UPDATE_TOLERANCE(x)
#define | TEST_EXPONENT_NON_ZERO(x)
#define | COINFACTORIZATION_BITS_PER_INT 32
#define | COINFACTORIZATION_SHIFT_PER_INT 5
#define | COINFACTORIZATION_MASK_PER_INT 0x1f
#define | ABC_DENSE_CODE 2

## Typedefs

typedef double | CoinSimplexDouble
typedef int | CoinSimplexInt
typedef unsigned int | CoinSimplexUnsignedInt
typedef unsigned int | CoinExponent
typedef unsigned char | CoinCheckZero

## Functions

template<class T>
void | CoinAbcMemset0 (T *to, const int size)
template<class T>
void | CoinAbcMemcpy (T *to, const T *from, const int size)

## Macro Definition Documentation

## COIN_FAC_NEW

#define COIN_FAC_NEW

Definition at line 8 of file CoinAbcCommon.hpp.

## ABC_INLINE

#define ABC_INLINE

Definition at line 30 of file CoinAbcCommon.hpp.

## ABC_PARALLEL

#define ABC_PARALLEL 0

Definition at line 36 of file CoinAbcCommon.hpp.

## cilk_for

#define cilk_for for

Definition at line 49 of file CoinAbcCommon.hpp.

## cilk_spawn

#define cilk_spawn

Definition at line 50 of file CoinAbcCommon.hpp.

## cilk_sync

#define cilk_sync

Definition at line 51 of file CoinAbcCommon.hpp.

## SLACK_VALUE

#define SLACK_VALUE 1

Definition at line 54 of file CoinAbcCommon.hpp.

## ABC_INSTRUMENT

#define ABC_INSTRUMENT 1

Definition at line 55 of file CoinAbcCommon.hpp.

## instrument_start

#define instrument_start | ( |  | name,
|  |  | x )

Definition at line 58 of file CoinAbcCommon.hpp.

## instrument_add

#define instrument_add | ( |  | x | ) |

Definition at line 59 of file CoinAbcCommon.hpp.

## instrument_end

#define instrument_end | ( |  | ) |

Definition at line 60 of file CoinAbcCommon.hpp.

## instrument_do

#define instrument_do | ( |  | name,
|  |  | x )

Definition at line 62 of file CoinAbcCommon.hpp.

## instrument_end_and_adjust

#define instrument_end_and_adjust | ( |  | x | ) |

Definition at line 64 of file CoinAbcCommon.hpp.

## ABC_INTEL

#define ABC_INTEL

Definition at line 76 of file CoinAbcCommon.hpp.

## CoinFabs

#define CoinFabs | ( |  | x | ) |

Value:
fabs(x)

Definition at line 86 of file CoinAbcCommon.hpp.

## TEST_DOUBLE_NONZERO

#define TEST_DOUBLE_NONZERO | ( |  | x | ) |

Value:
(true)

Definition at line 96 of file CoinAbcCommon.hpp.

## USE_TEST_INT_ZERO

#define USE_TEST_INT_ZERO

Definition at line 98 of file CoinAbcCommon.hpp.

## TEST_INT_NONZERO

#define TEST_INT_NONZERO | ( |  | x | ) |

Value:
(x)

Definition at line 100 of file CoinAbcCommon.hpp.

## TEST_DOUBLE_REALLY_NONZERO

#define TEST_DOUBLE_REALLY_NONZERO | ( |  | x | ) |

Value:
(x)

Definition at line 112 of file CoinAbcCommon.hpp.

## TEST_DOUBLE_NONZERO_REGISTER

#define TEST_DOUBLE_NONZERO_REGISTER | ( |  | x | ) |

Value:
(true)

Definition at line 122 of file CoinAbcCommon.hpp.

## USE_FIXED_ZERO_TOLERANCE

#define USE_FIXED_ZERO_TOLERANCE

Definition at line 124 of file CoinAbcCommon.hpp.

## TEST_LESS_THAN_TOLERANCE

#define TEST_LESS_THAN_TOLERANCE | ( |  | x | ) |

Value:
(fabs(x) < pow(0.5, 43))

Definition at line 136 of file CoinAbcCommon.hpp.

## TEST_LESS_THAN_UPDATE_TOLERANCE

#define TEST_LESS_THAN_UPDATE_TOLERANCE | ( |  | x | ) |

Value:
(fabs(x) < pow(0.5, 43))

Definition at line 137 of file CoinAbcCommon.hpp.

## TEST_LESS_THAN_TOLERANCE_REGISTER

#define TEST_LESS_THAN_TOLERANCE_REGISTER | ( |  | x | ) |

Value:
(fabs(x) < pow(0.5, 43))

Definition at line 146 of file CoinAbcCommon.hpp.

## ABC_EXPONENT

#define ABC_EXPONENT | ( |  | x | ) |

Value:
((reinterpret_cast< int * >(&x))[1] & 0x7ff00000)

Definition at line 155 of file CoinAbcCommon.hpp.

## TEST_EXPONENT_LESS_THAN_TOLERANCE

#define TEST_EXPONENT_LESS_THAN_TOLERANCE | ( |  | x | ) |

Value:
(x < 0x3d400000)

Definition at line 159 of file CoinAbcCommon.hpp.

## TEST_EXPONENT_LESS_THAN_UPDATE_TOLERANCE

#define TEST_EXPONENT_LESS_THAN_UPDATE_TOLERANCE | ( |  | x | ) |

Value:
(x < 0x3d400000)

Definition at line 160 of file CoinAbcCommon.hpp.

## TEST_EXPONENT_NON_ZERO

#define TEST_EXPONENT_NON_ZERO | ( |  | x | ) |

Value:
(x)

Definition at line 161 of file CoinAbcCommon.hpp.

## COINFACTORIZATION_BITS_PER_INT

#define COINFACTORIZATION_BITS_PER_INT 32

Definition at line 174 of file CoinAbcCommon.hpp.

## COINFACTORIZATION_SHIFT_PER_INT

#define COINFACTORIZATION_SHIFT_PER_INT 5

Definition at line 175 of file CoinAbcCommon.hpp.

## COINFACTORIZATION_MASK_PER_INT

#define COINFACTORIZATION_MASK_PER_INT 0x1f

Definition at line 176 of file CoinAbcCommon.hpp.

## ABC_DENSE_CODE

#define ABC_DENSE_CODE 2

Definition at line 221 of file CoinAbcCommon.hpp.

## Typedef Documentation

## CoinSimplexDouble

typedef double CoinSimplexDouble

Definition at line 21 of file CoinAbcCommon.hpp.

## CoinSimplexInt

typedef int CoinSimplexInt

Definition at line 22 of file CoinAbcCommon.hpp.

## CoinSimplexUnsignedInt

typedef unsigned int CoinSimplexUnsignedInt

Definition at line 23 of file CoinAbcCommon.hpp.

## CoinExponent

typedef unsigned int CoinExponent

Definition at line 153 of file CoinAbcCommon.hpp.

## CoinCheckZero

typedef unsigned char CoinCheckZero

Definition at line 226 of file CoinAbcCommon.hpp.

## Function Documentation

## CoinAbcMemset0()

template<class T>

void CoinAbcMemset0 | ( | T * | to,
|  | const int | size )

inline

Definition at line 229 of file CoinAbcCommon.hpp.

## CoinAbcMemcpy()

template<class T>

void CoinAbcMemcpy | ( | T * | to,
|  | const T * | from,
|  | const int | size )

inline

Definition at line 241 of file CoinAbcCommon.hpp.